<template>
  <FlexboxLayout flexWrap="wrap" class="bg-default">
    <StackLayout
      width="49%"
      :padding="itemPadding(index)"
      v-for="(category, index) in items"
      :key="index"
    >
      <!-- <Shadow>
        <StackLayout width="100%" backgroundColor="white">
          <Image
            backgroundColor="transparent"
            horizontalAlignment="center"
            width="100%"
            :src="category.ImageURLCover"
            @tap="$goToProductListScreen('product-category-product-list', {
              categoryId: category.ID,
            }, category.Name)"
          />
          <FlexBoxLayout
              class="quick_view_button"
              v-shadow="1"
              alignItems="center"
              justifyContent="center"
              :height="35"
              :backgroundColor="$colors.GREY"
              @tap="$goToProductListScreen('product-category-product-list', {
              categoryId: category.ID,
            }, category.Name)"
            >
              <Label class="font-roboto-regular" :text="category.Name" fontSize="10" />
            </FlexBoxLayout>
        </StackLayout>
      </Shadow>-->
      <CategoryCard
        :category="category"
        :sideBySide="true"
      />
    </StackLayout>
  </FlexboxLayout>
</template>

<script>
import Shadow from "~/components/Shadow/Thin";
import CategoryCard from "~/components/CategoryCard";
export default {
  components: {
    Shadow,
    CategoryCard
  },
  props: {
    categories: Array,
    random: Boolean,
    limit: Number
  },
  data() {
    return {
      items: []
    };
  },
  computed: {},
  watch: {
    categories() {
      this.items = this.getItems();
      console.log("items", this.items);
    }
  },
  beforeMount() {},
  mounted() {
    this.items = this.getItems();
  },
  methods: {
    itemPadding(index) {
      if (index % 2 === 0) {
        return "0 7 10 10";
      }
      return "0 10 10 7";
    },
    getItems() {
      if (this.random) {
        return this.getRandomItems(this.limit || this.categories.length);
      }
      return this.categories.filter(
        (b, index) => !this.limit || index < this.limit
      );
    },
    getRandomItems(numberOfItems) {
      const allIndexs = this.categories.map((b, index) => index);
      let selected = [];
      while (allIndexs.length > 0 && selected.length < numberOfItems) {
        const rand = this.$responsiveUI.getRandomNumber(
          0,
          allIndexs.length - 1
        );
        selected = selected.concat(allIndexs.splice(rand, 1));
        console.log(rand);
        console.log(selected);
      }
      return selected.map(index => this.categories[index]);
    }
  }
};
</script>

<style scoped>
.category-view-more {
  width: 100%;
  text-align: center;
  font-size: 12;
  font-family: "Roboto", "Roboto-Regular";
  font-weight: 400;
}
</style>
